/* drivers-dialog.c generated by valac 0.56.17, the Vala compiler
 * generated from drivers-dialog.vala, do not modify */

/*
 * Copyright (C) 2023 Bartłomiej Maryńczak
 * Author: Bartłomiej Maryńczak <marynczakbartlomiej@gmail.com>,
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DRIVERS_DIALOG (drivers_dialog_get_type ())
#define DRIVERS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRIVERS_DIALOG, DriversDialog))
#define DRIVERS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRIVERS_DIALOG, DriversDialogClass))
#define IS_DRIVERS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRIVERS_DIALOG))
#define IS_DRIVERS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRIVERS_DIALOG))
#define DRIVERS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRIVERS_DIALOG, DriversDialogClass))

typedef struct _DriversDialog DriversDialog;
typedef struct _DriversDialogClass DriversDialogClass;
typedef struct _DriversDialogPrivate DriversDialogPrivate;
enum  {
	DRIVERS_DIALOG_0_PROPERTY,
	DRIVERS_DIALOG_NUM_PROPERTIES
};
static GParamSpec* drivers_dialog_properties[DRIVERS_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _DriversDialogOpenData DriversDialogOpenData;

struct _DriversDialog {
	GtkWindow parent_instance;
	DriversDialogPrivate * priv;
};

struct _DriversDialogClass {
	GtkWindowClass parent_class;
};

struct _DriversDialogPrivate {
	GtkRevealer* header_revealer;
	GtkLabel* main_label;
	GtkLabel* main_sublabel;
	GtkRevealer* progress_revealer;
	GtkProgressBar* progress_bar;
	GtkLabel* result_label;
	GtkLabel* result_sublabel;
	GtkImage* result_icon;
	GtkStack* stack;
	guint pulse_timer;
	gchar* missing_driver;
};

struct _DriversDialogOpenData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DriversDialog* self;
	gchar* message;
	gchar* _tmp0_;
	gchar* instructions;
	gchar* _tmp1_;
	gchar** packages_to_install;
	gchar** _tmp2_;
	gint packages_to_install_length1;
	gint _packages_to_install_size_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GQuark _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GtkLabel* _tmp22_;
	const gchar* _tmp23_;
	GtkLabel* _tmp24_;
	const gchar* _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	GtkLabel* _tmp27_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	gchar** _tmp29_;
	gint _tmp29__length1;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
};

static gint DriversDialog_private_offset;
static gpointer drivers_dialog_parent_class = NULL;

VALA_EXTERN GType drivers_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DriversDialog, g_object_unref)
static void drivers_dialog_pulse_stop (DriversDialog* self);
VALA_EXTERN DriversDialog* drivers_dialog_new (GtkWindow* parent,
                                   const gchar* missing_driver);
VALA_EXTERN DriversDialog* drivers_dialog_construct (GType object_type,
                                         GtkWindow* parent,
                                         const gchar* missing_driver);
static void drivers_dialog_pulse_start (DriversDialog* self);
static gboolean __lambda45_ (DriversDialog* self);
static gboolean ___lambda45__gsource_func (gpointer self);
static void drivers_dialog_open_data_free (gpointer _data);
VALA_EXTERN void drivers_dialog_open (DriversDialog* self,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_);
VALA_EXTERN void drivers_dialog_open_finish (DriversDialog* self,
                                 GAsyncResult* _res_);
static gboolean drivers_dialog_open_co (DriversDialogOpenData* _data_);
static void drivers_dialog_finalize (GObject * obj);
static GType drivers_dialog_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
drivers_dialog_get_instance_private (DriversDialog* self)
{
	return G_STRUCT_MEMBER_P (self, DriversDialog_private_offset);
}

DriversDialog*
drivers_dialog_construct (GType object_type,
                          GtkWindow* parent,
                          const gchar* missing_driver)
{
	DriversDialog * self = NULL;
	gchar* _tmp0_;
#line 41 "../src/drivers-dialog.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 41 "../src/drivers-dialog.vala"
	self = (DriversDialog*) g_object_new (object_type, NULL);
#line 43 "../src/drivers-dialog.vala"
	_tmp0_ = g_strdup (missing_driver);
#line 43 "../src/drivers-dialog.vala"
	_g_free0 (self->priv->missing_driver);
#line 43 "../src/drivers-dialog.vala"
	self->priv->missing_driver = _tmp0_;
#line 44 "../src/drivers-dialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, parent);
#line 41 "../src/drivers-dialog.vala"
	return self;
#line 192 "drivers-dialog.c"
}

DriversDialog*
drivers_dialog_new (GtkWindow* parent,
                    const gchar* missing_driver)
{
#line 41 "../src/drivers-dialog.vala"
	return drivers_dialog_construct (TYPE_DRIVERS_DIALOG, parent, missing_driver);
#line 201 "drivers-dialog.c"
}

static gboolean
__lambda45_ (DriversDialog* self)
{
	GtkProgressBar* _tmp0_;
	gboolean result;
#line 55 "../src/drivers-dialog.vala"
	_tmp0_ = self->priv->progress_bar;
#line 55 "../src/drivers-dialog.vala"
	gtk_progress_bar_pulse (_tmp0_);
#line 56 "../src/drivers-dialog.vala"
	result = G_SOURCE_CONTINUE;
#line 56 "../src/drivers-dialog.vala"
	return result;
#line 217 "drivers-dialog.c"
}

static gboolean
___lambda45__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda45_ ((DriversDialog*) self);
#line 54 "../src/drivers-dialog.vala"
	return result;
#line 227 "drivers-dialog.c"
}

static void
drivers_dialog_pulse_start (DriversDialog* self)
{
#line 51 "../src/drivers-dialog.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/drivers-dialog.vala"
	drivers_dialog_pulse_stop (self);
#line 54 "../src/drivers-dialog.vala"
	self->priv->pulse_timer = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda45__gsource_func, g_object_ref (self), g_object_unref);
#line 239 "drivers-dialog.c"
}

static void
drivers_dialog_pulse_stop (DriversDialog* self)
{
#line 60 "../src/drivers-dialog.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/drivers-dialog.vala"
	g_source_remove (self->priv->pulse_timer);
#line 249 "drivers-dialog.c"
}

static void
drivers_dialog_open_data_free (gpointer _data)
{
	DriversDialogOpenData* _data_;
	_data_ = _data;
#line 13 "../src/drivers-dialog.vala"
	_g_object_unref0 (_data_->self);
#line 13 "../src/drivers-dialog.vala"
	g_slice_free (DriversDialogOpenData, _data_);
#line 261 "drivers-dialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 13 "../src/drivers-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 269 "drivers-dialog.c"
}

void
drivers_dialog_open (DriversDialog* self,
                     GAsyncReadyCallback _callback_,
                     gpointer _user_data_)
{
	DriversDialogOpenData* _data_;
	DriversDialog* _tmp0_;
#line 13 "../src/drivers-dialog.vala"
	g_return_if_fail (self != NULL);
#line 13 "../src/drivers-dialog.vala"
	_data_ = g_slice_new0 (DriversDialogOpenData);
#line 13 "../src/drivers-dialog.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 13 "../src/drivers-dialog.vala"
	g_task_set_task_data (_data_->_async_result, _data_, drivers_dialog_open_data_free);
#line 13 "../src/drivers-dialog.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 13 "../src/drivers-dialog.vala"
	_data_->self = _tmp0_;
#line 13 "../src/drivers-dialog.vala"
	drivers_dialog_open_co (_data_);
#line 293 "drivers-dialog.c"
}

void
drivers_dialog_open_finish (DriversDialog* self,
                            GAsyncResult* _res_)
{
	DriversDialogOpenData* _data_;
#line 13 "../src/drivers-dialog.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 303 "drivers-dialog.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 317 "drivers-dialog.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 321 "drivers-dialog.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 327 "drivers-dialog.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 332 "drivers-dialog.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 338 "drivers-dialog.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 342 "drivers-dialog.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 346 "drivers-dialog.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 350 "drivers-dialog.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 354 "drivers-dialog.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 358 "drivers-dialog.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 373 "drivers-dialog.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 382 "drivers-dialog.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 389 "drivers-dialog.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 395 "drivers-dialog.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 403 "drivers-dialog.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 407 "drivers-dialog.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 413 "drivers-dialog.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 418 "drivers-dialog.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 424 "drivers-dialog.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 428 "drivers-dialog.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 432 "drivers-dialog.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 438 "drivers-dialog.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 444 "drivers-dialog.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 456 "drivers-dialog.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 460 "drivers-dialog.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 464 "drivers-dialog.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 469 "drivers-dialog.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 477 "drivers-dialog.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 495 "drivers-dialog.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 501 "drivers-dialog.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 505 "drivers-dialog.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 513 "drivers-dialog.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 522 "drivers-dialog.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 531 "drivers-dialog.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 537 "drivers-dialog.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 545 "drivers-dialog.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 557 "drivers-dialog.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 563 "drivers-dialog.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 567 "drivers-dialog.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 575 "drivers-dialog.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 586 "drivers-dialog.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 595 "drivers-dialog.c"
	}
}

static gboolean
drivers_dialog_open_co (DriversDialogOpenData* _data_)
{
#line 69 "../src/drivers-dialog.vala"
	static GQuark _tmp5_label0 = 0;
#line 69 "../src/drivers-dialog.vala"
	static GQuark _tmp5_label1 = 0;
#line 69 "../src/drivers-dialog.vala"
	static GQuark _tmp5_label2 = 0;
#line 69 "../src/drivers-dialog.vala"
	static GQuark _tmp5_label3 = 0;
#line 69 "../src/drivers-dialog.vala"
	static GQuark _tmp5_label4 = 0;
#line 69 "../src/drivers-dialog.vala"
	static GQuark _tmp5_label5 = 0;
#line 69 "../src/drivers-dialog.vala"
	static GQuark _tmp5_label6 = 0;
#line 69 "../src/drivers-dialog.vala"
	static GQuark _tmp5_label7 = 0;
#line 69 "../src/drivers-dialog.vala"
	static GQuark _tmp5_label8 = 0;
#line 69 "../src/drivers-dialog.vala"
	static GQuark _tmp5_label9 = 0;
#line 65 "../src/drivers-dialog.vala"
	switch (_data_->_state_) {
#line 65 "../src/drivers-dialog.vala"
		case 0:
#line 626 "drivers-dialog.c"
		goto _state_0;
		default:
#line 65 "../src/drivers-dialog.vala"
		g_assert_not_reached ();
#line 631 "drivers-dialog.c"
	}
	_state_0:
#line 67 "../src/drivers-dialog.vala"
	_data_->_tmp0_ = g_strdup ("");
#line 67 "../src/drivers-dialog.vala"
	_data_->message = _data_->_tmp0_;
#line 67 "../src/drivers-dialog.vala"
	_data_->_tmp1_ = g_strdup ("");
#line 67 "../src/drivers-dialog.vala"
	_data_->instructions = _data_->_tmp1_;
#line 68 "../src/drivers-dialog.vala"
	_data_->_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 68 "../src/drivers-dialog.vala"
	_data_->packages_to_install = _data_->_tmp2_;
#line 68 "../src/drivers-dialog.vala"
	_data_->packages_to_install_length1 = 0;
#line 68 "../src/drivers-dialog.vala"
	_data_->_packages_to_install_size_ = _data_->packages_to_install_length1;
#line 69 "../src/drivers-dialog.vala"
	_data_->_tmp3_ = _data_->self->priv->missing_driver;
#line 69 "../src/drivers-dialog.vala"
	_data_->_tmp6_ = 0U;
#line 69 "../src/drivers-dialog.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 69 "../src/drivers-dialog.vala"
	_data_->_tmp6_ = (NULL == _data_->_tmp4_) ? 0 : g_quark_from_string (_data_->_tmp4_);
#line 69 "../src/drivers-dialog.vala"
	if ((((_data_->_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("brscan")))) || (_data_->_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("brscan2"))))) || (_data_->_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string ("brscan3"))))) || (_data_->_tmp6_ == ((0 != _tmp5_label3) ? _tmp5_label3 : (_tmp5_label3 = g_quark_from_static_string ("brscan4"))))) {
#line 69 "../src/drivers-dialog.vala"
		switch (0) {
#line 662 "drivers-dialog.c"
			default:
			{
#line 76 "../src/drivers-dialog.vala"
				_data_->_tmp7_ = g_strdup (_ ("You appear to have a Brother scanner."));
#line 76 "../src/drivers-dialog.vala"
				_g_free0 (_data_->message);
#line 76 "../src/drivers-dialog.vala"
				_data_->message = _data_->_tmp7_;
#line 78 "../src/drivers-dialog.vala"
				_data_->_tmp8_ = g_strdup (_ ("Drivers for this are available on the <a href=\"http://support.brother" \
".com\">Brother website</a>."));
#line 78 "../src/drivers-dialog.vala"
				_g_free0 (_data_->instructions);
#line 78 "../src/drivers-dialog.vala"
				_data_->instructions = _data_->_tmp8_;
#line 79 "../src/drivers-dialog.vala"
				break;
#line 679 "drivers-dialog.c"
			}
		}
	} else if (_data_->_tmp6_ == ((0 != _tmp5_label4) ? _tmp5_label4 : (_tmp5_label4 = g_quark_from_static_string ("pixma")))) {
#line 69 "../src/drivers-dialog.vala"
		switch (0) {
#line 685 "drivers-dialog.c"
			default:
			{
#line 82 "../src/drivers-dialog.vala"
				_data_->_tmp9_ = g_strdup (_ ("You appear to have a Canon scanner, which is supported by the <a href=" \
"\"http://www.sane-project.org/man/sane-pixma.5.html\">Pixma SANE backe" \
"nd</a>."));
#line 82 "../src/drivers-dialog.vala"
				_g_free0 (_data_->message);
#line 82 "../src/drivers-dialog.vala"
				_data_->message = _data_->_tmp9_;
#line 84 "../src/drivers-dialog.vala"
				_data_->_tmp10_ = g_strdup (_ ("Please check if your <a href=\"http://www.sane-project.org/sane-suppor" \
"ted-devices.html\">scanner is supported by SANE</a>, otherwise report " \
"the issue to the <a href=\"https://alioth-lists.debian.net/cgi-bin/mai" \
"lman/listinfo/sane-devel\">SANE mailing list</a>."));
#line 84 "../src/drivers-dialog.vala"
				_g_free0 (_data_->instructions);
#line 84 "../src/drivers-dialog.vala"
				_data_->instructions = _data_->_tmp10_;
#line 85 "../src/drivers-dialog.vala"
				break;
#line 702 "drivers-dialog.c"
			}
		}
	} else if (_data_->_tmp6_ == ((0 != _tmp5_label5) ? _tmp5_label5 : (_tmp5_label5 = g_quark_from_static_string ("samsung")))) {
#line 69 "../src/drivers-dialog.vala"
		switch (0) {
#line 708 "drivers-dialog.c"
			default:
			{
#line 88 "../src/drivers-dialog.vala"
				_data_->_tmp11_ = g_strdup (_ ("You appear to have a Samsung scanner."));
#line 88 "../src/drivers-dialog.vala"
				_g_free0 (_data_->message);
#line 88 "../src/drivers-dialog.vala"
				_data_->message = _data_->_tmp11_;
#line 91 "../src/drivers-dialog.vala"
				_data_->_tmp12_ = g_strdup (_ ("Drivers for this are available on the <a href=\"https://support.hp.com" \
"\">HP website</a> (HP acquired Samsung's printing business)."));
#line 91 "../src/drivers-dialog.vala"
				_g_free0 (_data_->instructions);
#line 91 "../src/drivers-dialog.vala"
				_data_->instructions = _data_->_tmp12_;
#line 92 "../src/drivers-dialog.vala"
				break;
#line 725 "drivers-dialog.c"
			}
		}
	} else if ((_data_->_tmp6_ == ((0 != _tmp5_label6) ? _tmp5_label6 : (_tmp5_label6 = g_quark_from_static_string ("hpaio")))) || (_data_->_tmp6_ == ((0 != _tmp5_label7) ? _tmp5_label7 : (_tmp5_label7 = g_quark_from_static_string ("smfp"))))) {
#line 69 "../src/drivers-dialog.vala"
		switch (0) {
#line 731 "drivers-dialog.c"
			default:
			{
#line 96 "../src/drivers-dialog.vala"
				_data_->_tmp13_ = g_strdup (_ ("You appear to have an HP scanner."));
#line 96 "../src/drivers-dialog.vala"
				_g_free0 (_data_->message);
#line 96 "../src/drivers-dialog.vala"
				_data_->message = _data_->_tmp13_;
#line 97 "../src/drivers-dialog.vala"
				_data_->_tmp14_ = _data_->self->priv->missing_driver;
#line 97 "../src/drivers-dialog.vala"
				if (g_strcmp0 (_data_->_tmp14_, "hpaio") == 0) {
#line 98 "../src/drivers-dialog.vala"
					_data_->_tmp15_ = g_strdup ("libsane-hpaio");
#line 98 "../src/drivers-dialog.vala"
					_data_->_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 98 "../src/drivers-dialog.vala"
					_data_->_tmp16_[0] = _data_->_tmp15_;
#line 98 "../src/drivers-dialog.vala"
					_data_->packages_to_install = (_vala_array_free (_data_->packages_to_install, _data_->packages_to_install_length1, (GDestroyNotify) g_free), NULL);
#line 98 "../src/drivers-dialog.vala"
					_data_->packages_to_install = _data_->_tmp16_;
#line 98 "../src/drivers-dialog.vala"
					_data_->packages_to_install_length1 = 1;
#line 98 "../src/drivers-dialog.vala"
					_data_->_packages_to_install_size_ = _data_->packages_to_install_length1;
#line 758 "drivers-dialog.c"
				} else {
#line 104 "../src/drivers-dialog.vala"
					_data_->_tmp17_ = g_strdup (_ ("Drivers for this are available on the <a href=\"https://support.hp.com" \
"\">HP website</a>."));
#line 104 "../src/drivers-dialog.vala"
					_g_free0 (_data_->instructions);
#line 104 "../src/drivers-dialog.vala"
					_data_->instructions = _data_->_tmp17_;
#line 766 "drivers-dialog.c"
				}
#line 105 "../src/drivers-dialog.vala"
				break;
#line 770 "drivers-dialog.c"
			}
		}
	} else if (_data_->_tmp6_ == ((0 != _tmp5_label8) ? _tmp5_label8 : (_tmp5_label8 = g_quark_from_static_string ("epkowa")))) {
#line 69 "../src/drivers-dialog.vala"
		switch (0) {
#line 776 "drivers-dialog.c"
			default:
			{
#line 108 "../src/drivers-dialog.vala"
				_data_->_tmp18_ = g_strdup (_ ("You appear to have an Epson scanner."));
#line 108 "../src/drivers-dialog.vala"
				_g_free0 (_data_->message);
#line 108 "../src/drivers-dialog.vala"
				_data_->message = _data_->_tmp18_;
#line 110 "../src/drivers-dialog.vala"
				_data_->_tmp19_ = g_strdup (_ ("Drivers for this are available on the <a href=\"http://support.epson.c" \
"om\">Epson website</a>."));
#line 110 "../src/drivers-dialog.vala"
				_g_free0 (_data_->instructions);
#line 110 "../src/drivers-dialog.vala"
				_data_->instructions = _data_->_tmp19_;
#line 111 "../src/drivers-dialog.vala"
				break;
#line 793 "drivers-dialog.c"
			}
		}
	} else if (_data_->_tmp6_ == ((0 != _tmp5_label9) ? _tmp5_label9 : (_tmp5_label9 = g_quark_from_static_string ("lexmark_nscan")))) {
#line 69 "../src/drivers-dialog.vala"
		switch (0) {
#line 799 "drivers-dialog.c"
			default:
			{
#line 114 "../src/drivers-dialog.vala"
				_data_->_tmp20_ = g_strdup (_ ("You appear to have a Lexmark scanner."));
#line 114 "../src/drivers-dialog.vala"
				_g_free0 (_data_->message);
#line 114 "../src/drivers-dialog.vala"
				_data_->message = _data_->_tmp20_;
#line 116 "../src/drivers-dialog.vala"
				_data_->_tmp21_ = g_strdup (_ ("Drivers for this are available on the <a href=\"http://support.lexmark" \
".com\">Lexmark website</a>."));
#line 116 "../src/drivers-dialog.vala"
				_g_free0 (_data_->instructions);
#line 116 "../src/drivers-dialog.vala"
				_data_->instructions = _data_->_tmp21_;
#line 117 "../src/drivers-dialog.vala"
				break;
#line 816 "drivers-dialog.c"
			}
		}
	}
#line 120 "../src/drivers-dialog.vala"
	_data_->_tmp22_ = _data_->self->priv->main_label;
#line 120 "../src/drivers-dialog.vala"
	_data_->_tmp23_ = _data_->message;
#line 120 "../src/drivers-dialog.vala"
	gtk_label_set_label (_data_->_tmp22_, _data_->_tmp23_);
#line 121 "../src/drivers-dialog.vala"
	_data_->_tmp24_ = _data_->self->priv->main_sublabel;
#line 121 "../src/drivers-dialog.vala"
	_data_->_tmp25_ = _data_->instructions;
#line 121 "../src/drivers-dialog.vala"
	gtk_label_set_label (_data_->_tmp24_, _data_->_tmp25_);
#line 123 "../src/drivers-dialog.vala"
	_data_->_tmp26_ = _data_->packages_to_install;
#line 123 "../src/drivers-dialog.vala"
	_data_->_tmp26__length1 = _data_->packages_to_install_length1;
#line 123 "../src/drivers-dialog.vala"
	if (_data_->_tmp26__length1 > 0) {
#line 175 "../src/drivers-dialog.vala"
		_data_->_tmp27_ = _data_->self->priv->main_sublabel;
#line 175 "../src/drivers-dialog.vala"
		_data_->_tmp28_ = _data_->packages_to_install;
#line 175 "../src/drivers-dialog.vala"
		_data_->_tmp28__length1 = _data_->packages_to_install_length1;
#line 175 "../src/drivers-dialog.vala"
		_data_->_tmp29_ = _data_->packages_to_install;
#line 175 "../src/drivers-dialog.vala"
		_data_->_tmp29__length1 = _data_->packages_to_install_length1;
#line 175 "../src/drivers-dialog.vala"
		_data_->_tmp30_ = _vala_g_strjoinv (", ", _data_->_tmp29_, (gint) _data_->_tmp29__length1);
#line 175 "../src/drivers-dialog.vala"
		_data_->_tmp31_ = _data_->_tmp30_;
#line 175 "../src/drivers-dialog.vala"
		_data_->_tmp32_ = g_strdup_printf (ngettext ("You need to install the %s package.", "You need to install the %s packages.", (gulong) _data_->_tmp28__length1), _data_->_tmp31_);
#line 175 "../src/drivers-dialog.vala"
		_data_->_tmp33_ = _data_->_tmp32_;
#line 175 "../src/drivers-dialog.vala"
		gtk_label_set_text (_data_->_tmp27_, _data_->_tmp33_);
#line 175 "../src/drivers-dialog.vala"
		_g_free0 (_data_->_tmp33_);
#line 175 "../src/drivers-dialog.vala"
		_g_free0 (_data_->_tmp31_);
#line 177 "../src/drivers-dialog.vala"
		gtk_window_present ((GtkWindow*) _data_->self);
#line 864 "drivers-dialog.c"
	}
#line 65 "../src/drivers-dialog.vala"
	_data_->packages_to_install = (_vala_array_free (_data_->packages_to_install, _data_->packages_to_install_length1, (GDestroyNotify) g_free), NULL);
#line 65 "../src/drivers-dialog.vala"
	_g_free0 (_data_->instructions);
#line 65 "../src/drivers-dialog.vala"
	_g_free0 (_data_->message);
#line 65 "../src/drivers-dialog.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 65 "../src/drivers-dialog.vala"
	if (_data_->_state_ != 0) {
#line 65 "../src/drivers-dialog.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 65 "../src/drivers-dialog.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 880 "drivers-dialog.c"
		}
	}
#line 65 "../src/drivers-dialog.vala"
	g_object_unref (_data_->_async_result);
#line 65 "../src/drivers-dialog.vala"
	return FALSE;
#line 887 "drivers-dialog.c"
}

static void
drivers_dialog_class_init (DriversDialogClass * klass,
                           gpointer klass_data)
{
#line 13 "../src/drivers-dialog.vala"
	drivers_dialog_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/drivers-dialog.vala"
	g_type_class_adjust_private_offset (klass, &DriversDialog_private_offset);
#line 13 "../src/drivers-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = drivers_dialog_finalize;
#line 13 "../src/drivers-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/SimpleScan/ui/drivers-dialog.ui");
#line 13 "../src/drivers-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "header_revealer", FALSE, DriversDialog_private_offset + G_STRUCT_OFFSET (DriversDialogPrivate, header_revealer));
#line 13 "../src/drivers-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_label", FALSE, DriversDialog_private_offset + G_STRUCT_OFFSET (DriversDialogPrivate, main_label));
#line 13 "../src/drivers-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_sublabel", FALSE, DriversDialog_private_offset + G_STRUCT_OFFSET (DriversDialogPrivate, main_sublabel));
#line 13 "../src/drivers-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "progress_revealer", FALSE, DriversDialog_private_offset + G_STRUCT_OFFSET (DriversDialogPrivate, progress_revealer));
#line 13 "../src/drivers-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "progress_bar", FALSE, DriversDialog_private_offset + G_STRUCT_OFFSET (DriversDialogPrivate, progress_bar));
#line 13 "../src/drivers-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "result_label", FALSE, DriversDialog_private_offset + G_STRUCT_OFFSET (DriversDialogPrivate, result_label));
#line 13 "../src/drivers-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "result_sublabel", FALSE, DriversDialog_private_offset + G_STRUCT_OFFSET (DriversDialogPrivate, result_sublabel));
#line 13 "../src/drivers-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "result_icon", FALSE, DriversDialog_private_offset + G_STRUCT_OFFSET (DriversDialogPrivate, result_icon));
#line 13 "../src/drivers-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, DriversDialog_private_offset + G_STRUCT_OFFSET (DriversDialogPrivate, stack));
#line 920 "drivers-dialog.c"
}

static void
drivers_dialog_instance_init (DriversDialog * self,
                              gpointer klass)
{
#line 13 "../src/drivers-dialog.vala"
	self->priv = drivers_dialog_get_instance_private (self);
#line 13 "../src/drivers-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 931 "drivers-dialog.c"
}

static void
drivers_dialog_finalize (GObject * obj)
{
	DriversDialog * self;
#line 13 "../src/drivers-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DRIVERS_DIALOG, DriversDialog);
#line 48 "../src/drivers-dialog.vala"
	drivers_dialog_pulse_stop (self);
#line 39 "../src/drivers-dialog.vala"
	_g_free0 (self->priv->missing_driver);
#line 13 "../src/drivers-dialog.vala"
	G_OBJECT_CLASS (drivers_dialog_parent_class)->finalize (obj);
#line 946 "drivers-dialog.c"
}

static GType
drivers_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DriversDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drivers_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DriversDialog), 0, (GInstanceInitFunc) drivers_dialog_instance_init, NULL };
	GType drivers_dialog_type_id;
	drivers_dialog_type_id = g_type_register_static (gtk_window_get_type (), "DriversDialog", &g_define_type_info, 0);
	DriversDialog_private_offset = g_type_add_instance_private (drivers_dialog_type_id, sizeof (DriversDialogPrivate));
	return drivers_dialog_type_id;
}

GType
drivers_dialog_get_type (void)
{
	static volatile gsize drivers_dialog_type_id__once = 0;
	if (g_once_init_enter (&drivers_dialog_type_id__once)) {
		GType drivers_dialog_type_id;
		drivers_dialog_type_id = drivers_dialog_get_type_once ();
		g_once_init_leave (&drivers_dialog_type_id__once, drivers_dialog_type_id);
	}
	return drivers_dialog_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

